
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>javascript中的函数式声明与变量式声明 / 憋错料</title>

    <meta name="description" content="javascript中的函数式声明与变量式声明 观察下面两段代码,试写出hello('word');的运行结果: // 变量式声明 function hello(msg){ alert(msg); var msg = function(){}; alert(msg); } //函数式声明 function hello(msg){ alert(msg); function msg (){}; alert(msg); } 对于变量式声明,首先弹出word,然后弹出function,而函数式声明,则两次都是弹出function.这是为什么呢? 一:">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">javascript中的函数式声明与变量式声明</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>观察下面两段代码，试写出hello(‘word‘);的运行结果：</p>
<pre>// 变量式声明
function hello(msg){
   alert(msg);
   var msg = function(){};
   alert(msg);
}

//函数式声明
function hello(msg){
   alert(msg);
   function msg (){};
   alert(msg);
}</pre>
<p>对于变量式声明，首先弹出word,然后弹出function,而函数式声明，则两次都是弹出function.这是为什么呢？</p>
<p>一: 函数式声明</p>
<pre>function hello(msg){
   alert(msg); //放在最前面的位置打印msg，是function
   function msg(){
      //这个msg是函数式声明，它会贯穿于整个fun函数的作用域
      //也就是说，只要fun一旦调用，甚至只要是进入语法分析阶段
      //那么msg函数就会首先解析，你可以把它想象成它是在fun函数
      //内的第一个变量。有的书上称这种现象为声明被提前或提升。
   }
   alert(msg);//放在最末尾的位置打印msg，也是function
  // 说明函数式声明在hello作用域内部是贯穿的
}</pre>
<p>二：变量式声明</p>
<pre>function hello(msg){
　alert(abc); // 此时为undefined

   var abc = function(){
    //这种是变量式声明，它在fun函数内的位置是固定的，也就是说
    // var abc之前，abc的值在fun内是undefined
    // var abc之后，abc才是它声明的值
    // 这种方式你可以理解成在fun函数的第一行写了一个var abc;
    // 也正因为如此，fun内声明的变量，会切断外部变量的引用；
    // 不论在hello作用域之外，abc的值是多少，在hello内部，在var abc之前，始终是undefined
    // 这是面试官最喜欢光顾的地方之一
   }

   alert(abc); // 此时才是function

   // 这里把abc换成msg，道理也是一样的。对于hello内部来说，它的形参，就相当于是hello内部的局部变量。   // 这里有意用abc来替换msg，其实是为了简化问题，减少干扰项。既然是都hello内的局域变量，那么在声明之前   // 它的值为undefined也就是理所当然的事了。这里唯一有个要注意的地方就是，形参的声明，出现在所有局部变量之前。   // 后面对局部变量进行重复声明，系统会直接无视重复的声明过程，但是声明同时有赋值的话除外。
 }</pre>
<p>总结一点：函数式声明会上升到所属作用域的最前面，&nbsp;变量式声明则不会.</p>

<p>最后补充一点：</p>
<pre>var abc = function(){};</pre>
<p>实际上是abc保存了一个无名函数的引用；本质上abc还是一个变量.</p>
<p>而 function abc(){} 是一个有名函数；本质上abc是函数;</p>


<p>如果你喜欢，你可以用多个变量保存同一个函数的引用：</p>

<pre>var xxx = abc; var bbb = abc;</pre>
<p>引用可以无数，但是真身始终唯一。</p>
<p>// xxx = null,bbb=null之后，abc该干嘛干嘛，而 var abc = function(){}; abc = null之后你就彻底的失去了有关abc的一切。</p>
<p>abc从此石沉大海，从江湖上隐姓埋名，销声匿迹.......</p>

<p>虽然两者在功能上是等价的，但是呢，我个人还是蛮倾向于把子函数，&nbsp;人为的写在前面，这是为了避免压缩合并时，造成各种意外的结果。</p>
<p>如果不是通用方法，我习惯用变量式声明，当然，这只是个人习惯。</p>

<p>对于函数式声明，它在整个作用域内可见，有的书上说是声明提升，有的说是声明提前。其实叫什么不重要，理解这种现象发生了什么，会产生什么影响才是根本。</p>
<p>最后还要强调一点：命名函数表达式的名字只在该函数的作用域内部有效。也就是说，在hello函数内，无论用哪种方式声明msg这个函数，那么出了hello函数，都是不存在的。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 18:07:36 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>javascript中的函数式声明与变量式声明的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0x5JPk3.html" rel="bookmark">JS函数式编程【译】4&period;在Javascript中实现函数式编程的技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				?? Functional Programming in Javascript 主目录上一章 建立函数式编程环境 第四章 在Javascript中实现函数式编程的技术 扶好你的帽子,我们现在要真正进入函数式的思想了. 这章我们继续下面的内容: 把所有的核心概念放到一个集中的范式里 探索函数式编程之美 一步步跟踪函数式模式相互交织的逻辑 我们将贯穿整章建立一个简单的应用做一些很酷的事情 你可能已经注意到,在上一章我们介绍Javascript的函数式库的时候引入了一些概念, 而不是在第二章&lt;函数式编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qYVx73.html" rel="bookmark">var声明的变量以及声明的函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;html&gt; &lt;body&gt; &lt;script&gt; //所有用var声明的变量以及声明的函数 /*var  a = 1; function f(){        alert(a);    var a  = 5; }f();*//*var  a = 1; function f(){        alert(a);     a  = 8;}f();*///上面的代码的处理过程 //    ******全局处理****/*1. 在预处理的阶段:    1.1 读取分析整个源代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wvrQY0.html" rel="bookmark">Javascript 中的函数式编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文和大家分享的主要是javascript中函数式编程相关内容,一起来看看吧,希望对大家学习javascript有所帮助. 函数式编程(functional programming)或称函数程序设计,又称泛函编程,是一种编程范型,比起命令式编程,函数式编程更加强调程序执行的结果而非执行的过程,倡导利用若干简单的执行单元让计算结果不断渐进,逐层推导复杂的运算,而不是设计一个复杂的执行过程. 函数式编程,近年来一直被炒得火热,国内外的开发者好像都在议论和提倡这种编程范式.在众多的函数式语言中,Jav			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M68ONW3.html" rel="bookmark">javascript中的正則表達式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对文本数据进行操作是JavaScript中常见的任务.正則表達式通过同意程序猿指定字符串匹配的模式来简化诸如验证表单中输入是否具有正确格式之类的任务. 1.正則表達式标记: 字符 含义 举例 i 大写和小写不敏感 对于模式/http/i  &quot;http&quot; 和&quot;HttP&quot; 一样能够匹配 g 全局匹配.找出所有匹配字符串,而不不过找到第一个就返回. 经常使用于替换 m 多行匹配 2.正則表達式位置指示符:规定模式在它所匹配的字符串里的位置. 字符 含义 举例 ^ 开头 对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aROLR3.html" rel="bookmark">JavaScript中valueOf、toString的隐式调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在群上有人问这样一个问题: 函数add可以实现连续的加法运算函数add语法如下add(num1)(num2)(num3)...;//注意这里是省略号哟,无限使用举例如下:add(10)(10)=20;add(10)(20)(50)=80;add(10)(20)(50)(100)=180;请用js代码实现函数add. 自个琢磨了一会只能Google之,代码如下: function add(num){ var sum=num, tmp=function(v){ sum+=v; return tm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoGANkM.html" rel="bookmark">匿名内部类不能访问外部类方法中的局部变量，除非变量被声明为final类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 这里所说的“匿名内部类”主要是指在其外部类的成员方法内定义,同时完成实例化的类,若其访问该成员方法中的局部变量,局部变量必须要被final修饰.2. 原因是编译程序实现上的困难:内部类对象的生命周期会超过局部变量的生命周期.局部变量的生命周期:当该方法被调用时,该方法中的局部变量在栈中被创建,当方法调用结束时,退栈,这些局部变量全部死亡.而内部类对象生命周期与其它类一样:自创建一个匿名内部类对象,系统为该对象分配内存,直到没有引用变量指向分配给该对象的内存,它才会死亡(被JVM垃圾回收).			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xx7eN0.html" rel="bookmark">Javascript中的循环变量声明，到底应该放在哪儿？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不放走任何一个细节.相信很多Javascript开发者都在声明循环变量时犹豫过var i到底应该放在哪里:放在不同的位置会对程序的运行产生怎样的影响?哪一种方式符合Javascript的语言规范?哪一种方式和ecma标准未来的发展方向匹配?本文将对四种常见的声明循环变量的书写方式进行简单的分析和比较. 习惯1:不声明直接使用 function loop(arr) { for (i = 0; i &lt; arr.length; i++) { // do something } } 非常危险的使用习惯,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmeJ2VM.html" rel="bookmark">【JavaScript】Javascript中的函数声明和函数表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Javascript有很多有趣的用法,在Google Code Search里能找到不少,举一个例子: &lt;script&gt; ~function() { alert(&quot;hello, world.&quot;); }(); &lt;/script&gt; 试一下就知道这段代码的意思就是声明一个函数,然后立刻执行,因为Javascript中的变量作用域是基于函数的,所以这样可以避免变量污染,但这里的位运算符『~』乍一看让人摸不到头脑,如果去掉它再运行则会报错:SyntaxError. 在阐述			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmLEbP4.html" rel="bookmark">JavaScript中函数式编程中文翻译</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原著由 Dan Mantyla 编写 近几年来,随着 Haskell.Scala.Clojure 等学院派原生支持函数式编程的偏门语言越来越受到关注,同时主流的 Java.JavaScript.Python 甚至 C++都陆续支持函数式编程.特别值得一提的是,在 nodejs 出现后,JavaScript 成为第一种从前端到后台的全栈语言,而且 JavaScript 支持多范式编程.应用函数式编程的最大挑战就是思维模式的改变———从传统面向对象的范式变为函数式编程范式. &lt;JavaScript			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/74Q8zw3.html" rel="bookmark" class="title">每天学一点JAVA</a>
					<div>
						1.JAVA的反射机制 在运行时判断任意一个对象所属的类:在运行时构造任意一个类的对象:在运行时判断任意一个类所具有的成员变量和方法:在运行时调用任意一个对象的方法:生成动态代理. 2.关于ARRAY ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgPxn0.html" rel="bookmark" class="title">15&period;8</a>
					<div>
						import java.awt.*; import java.util.Scanner; import javax.swing.*; public class Test extends JFrame{ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lpWL0.html" rel="bookmark" class="title">工厂设计模式</a>
					<div>
						工厂设计模式:是一种创建对象的模式,使代码的耦合.工厂模式就是给外部批量提供相同或者不同的产品,而外部不需要关心工厂是如何创建一个复杂产品的过程.所以工厂模式可以降低模块间的耦合,同时可以提高扩展性( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0byxyVM.html" rel="bookmark" class="title">java打jar包</a>
					<div>
						一.打包jar文件 1      如果是class文件     jar cvf myjar.jar Foo.class Bar.class 如果是包     jar cvf myjar.jar pac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OmrY8M.html" rel="bookmark" class="title">接口的特点</a>
					<div>
						接口是一些方法特征的集合. 接口中定义的方法默认使用&quot;public abstract&quot;来修饰,即抽象方法.接口中的变量默认使用&quot;public static final & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2LWa3.html" rel="bookmark" class="title">mongoDB 学习七</a>
					<div>
						MongoDB 更新文档 MongoDB 使用 update() 和 save() 方法来更新集合中的文档.接下来让我们详细来看下两个函数的应用及其区别. update() 方法 update() 方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YY7eX0.html" rel="bookmark" class="title">用模块化编程</a>
					<div>
						用模块化编程 最近想边学边整一下模块化编程,那么先从为何要使用模块化编程说起吧,可能你刚听说模块化编程,也没有关系,本篇讲的是很基础的东西. 一开始写代码的时候,我们可能只需要一个js文件,去实现一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRN1o0.html" rel="bookmark" class="title">（模拟） hdu 1698</a>
					<div>
						Just a Hook Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvv1v3.html" rel="bookmark" class="title">模拟注册以及登陆：作业题练习</a>
					<div>
						/**模拟注册以及登陆: 1.注册不知道用户的操作次数,所以需要使用死循环 2.当用户确定了用户名和密码后,注册成功,保存下用户输入的用户名以及密码 3.登陆最多只能三次,如果第三次还没有成功直接退出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDqOmM.html" rel="bookmark" class="title">lua学习笔记15：table数组逆序</a>
					<div>
						数组的逆序,只能用于数组,不能用于哈希表 function reverseTable(tab) local tmp = {} for i = 1, #tab do local key = #tab t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORdRZ0.html" rel="bookmark" class="title">四、GPIO</a>
					<div>
						参考自linux-2.6.32.61\Documentation\ 一.简介 GPIO全称是General Purpose Input/Output,其关联SOC上的一个管脚.平台会分配相应的GPIO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eyWDb0.html" rel="bookmark" class="title">android四大组件--ContentProvider详解</a>
					<div>
						一.相关ContentProvider概念解析: 1.ContentProvider简介 在Android官方指出的Android的数据存储方式总共有五种,分别是:Shared Preferences ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ORbVg0.html" rel="bookmark" class="title">过滤器与拦截器之间的关系与区别</a>
					<div>
						Java过滤器与SpringMVC拦截器之间的关系与区别http://blog.csdn.net/chenleixing/article/details/44573495 今天学习和认识了一下,过滤器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47wpQ64.html" rel="bookmark" class="title">为什么说Java匿名内部类是残缺的闭包</a>
					<div>
						前言 我们先来看一道很简单的小题: public class AnonymousDemo1 { public static void main(String args[]) { new Anonymo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDpvaM.html" rel="bookmark" class="title">ELKStack 实战之 Elasticsearch &lbrack;一&rsqb;</a>
					<div>
						ELKStack 实战之 Elasticsearch [一] 标签(空格分隔): ELKStack ELKStack简介 ELK Stack 是 Elasticsearch.Logstash.Kiba ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBx9DY3.html" rel="bookmark" class="title">Python学习笔记（二）：字典</a>
					<div>
						字典由多个键及与其对应的值构成的键值对构成,字典中键唯一,值不唯一. 1)dict 函数: &gt;&gt;&gt;items=[('name','lilei'),('age',12)] &gt;&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymOJAM.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;程序媛&rdquo;往往比&OpenCurlyDoubleQuote;程序猿&rdquo;更受认可，但前提是不能公开性别</a>
					<div>
						摘要: 科技圈的性别歧视早已不是新鲜,女性程序员的代码接受率可以达到78.6%,比男性程序员的74.6%要高.然而,若女程序员对外公开自己的性别,其代码接受率便出现了大幅下降,只剩下62.5%. 钛媒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvXmm3.html" rel="bookmark" class="title">DFS &plus; 剪枝策略</a>
					<div>
						一:简介 (1)相信做过ACM的人,都很熟悉图和树的深度优先搜索:算法里面有蛮力法 -- 就是暴力搜索(不加任何剪枝的搜索): (2)蛮力搜搜需要优化时,就是需要不停的剪枝,提前减少不必要的搜索路径, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l79RPM.html" rel="bookmark" class="title">《软件工程概论》第四章核心内容</a>
					<div>
						结构化设计方法是在模块化.自顶向下逐步细化及结构华程序设计技术基础之上发展起来的.结构化设计方法可以分为两类,一类是根据系统的数据流进行设计,称为面向数据流设计或称过程驱动设计:另一类是根据系统的数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9j1d4.html" rel="bookmark" class="title">Delphi中TStringList类常用属性方法详解</a>
					<div>
						//TStringList 常用方法与属性: var List: TStringList; i: Integer; begin List := TStringList.Create; List.Add ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
